class Panel::PersonalConference::BackEnd::WritingConferencesController < OrbitBackendController
  include AdminHelper
  include OrbitControllerLib::DivisionForDisable
  
  before_filter :authenticate_user!

  before_filter :only => [ :new,:edit,:update] do |controller|
    controller.get_categorys('WritingConferenceCategory')
  end

  def index
    get_plugins

    # @tags = get_tags
    # @categories = get_categories_for_index
    # @statuses = get_statuses
    # category_ids = @categories.collect{|t| t.id}
    @paper_type_ids = ConferencePaperType.all.collect{|t| t.id.to_s} + [nil]

    @writing_conferences = get_sorted_and_filtered("writing_conference", :conference_paper_type_id.in => @paper_type_ids)
    respond_to do |format|
      format.html # index.html.erb
      format.js { }
      format.xml  { render :xml => @writing_conferences }
    end
  end

  def writing_conference_setting
  
    get_plugins
  
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	
    @tags = get_tags
	
    @set_author_type = ConferenceAuthorType.new(:display => 'List')
  	@author_type_url = panel_personal_conference_back_end_writing_conferences_path
	
    @set_paper_type = ConferencePaperType.new(:display => 'List')
  	@paper_type_url = panel_personal_conference_back_end_writing_conferences_path
	
	
  end

  def paper_type_quick_add    
    @set_paper_type = ConferencePaperType.new(:display => 'List')
    @paper_type_url = panel_personal_conference_back_end_writing_conferences_path
    @set_paper_type.id = params[:id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def paper_type_quick_edit
  
    @set_paper_type = ConferencePaperType.find(params[:writing_conference_id])
    @paper_type_url = panel_personal_conference_back_end_writing_conference_path(@set_paper_type)
	
    respond_to do |format|
      format.js
    end
  end

  def author_type_quick_add    
    @set_author_type = ConferenceAuthorType.new(:display => 'List')
    @author_type_url = panel_personal_conference_back_end_writing_conferences_path
    @set_author_type.id = params[:id]
	
    respond_to do |format|
      format.js
    end
	
  end

  def author_type_quick_edit
  
    @set_author_type = ConferenceAuthorType.find(params[:writing_conference_id])
    @author_type_url = panel_personal_conference_back_end_writing_conference_path(@set_author_type)
	
    respond_to do |format|
      format.js
    end
  end

  # GET /writing_conferences/1
  # GET /writing_conferences/1.xml
  def show
    @writing_conference = WritingConference.find(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @writing_conference }
    end
  end

  # GET /writing_conferences/new
  # GET /writing_conferences/new.xml
  def new
  
    get_plugins
	
    @writing_conference = WritingConference.new
    # @writing_conference_files = WritingConferenceFile.all
    # @paper_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
    @tags = get_tags

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @writing_conference }
    end
  end

  # GET /writing_conferences/1/edit
  def edit
  
    get_plugins
	
    @writing_conference = WritingConference.find(params[:id])
	
    # @paper_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	
    @tags = get_tags
  end

  # POST /writing_conferences
  # POST /writing_conferences.xml
  def create
  
  if params[:conference_paper_type]
		
		@conference_paper_type = ConferencePaperType.new(params[:conference_paper_type])

		respond_to do |format|
		  if @conference_paper_type.save
			format.js { render 'create_writing_conference_setting' }
		  end
		end
  
   elsif params[:conference_author_type]
		
		@conference_author_type = ConferenceAuthorType.new(params[:conference_author_type])

		respond_to do |format|
		  if @conference_author_type.save
			format.js { render 'create_writing_conference_setting' }
		  end
		end
	
  else
	
    # @paper_types = ConferenceLevelType.all
    @author_types = ConferenceAuthorType.all
    @paper_types = ConferencePaperType.all
	  @tags = get_tags
  
    @writing_conference = WritingConference.new(params[:writing_conference])
	
	  if params[:writing_conference][:user_id]
      @writing_conference.create_user_id = params[:writing_conference][:user_id]
      @writing_conference.update_user_id = params[:writing_conference][:user_id]
    else
	    @writing_conference.create_user_id = current_user.id
      @writing_conference.update_user_id = current_user.id
    end

    respond_to do |format|
      if @writing_conference.save
	  
		    if params[:writing_conference][:user_id]
          format.html { redirect_to(admin_users_new_interface_url(:id=>params[:writing_conference][:user_id],:show_plugin_profile=>'WritingConference')) }
        else
		      format.html { redirect_to(panel_personal_conference_back_end_writing_conferences_url) }
        end
		
        format.xml  { render :xml => @writing_conference, :status => :created, :location => @writing_conference }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @writing_conference.errors, :status => :unprocessable_entity }
      end
    end
  end

  end

  # PUT /writing_conferences/1
  # PUT /writing_conferences/1.xml
  def update
  
	if params[:conference_paper_type]
  	
  		@conference_paper_type = ConferencePaperType.find(params[:id])

  		respond_to do |format|
            
  		  if @conference_paper_type.update_attributes(params[:conference_paper_type])
  			# format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
  			format.js { render 'update_writing_conference_setting' }
  		  end
  		end
		
	elsif params[:conference_author_type]
  	
  		@conference_author_type = ConferenceAuthorType.find(params[:id])

  		respond_to do |format|
            
  		  if @conference_author_type.update_attributes(params[:conference_author_type])
  			# format.html { redirect_to(panel_announcement_back_end_bulletins_url) }
  			format.js { render 'update_writing_conference_setting' }
  		  end
  		end
		
  	else
	
      @writing_conference = WritingConference.find(params[:id])
  	
      @writing_conference.update_user_id = current_user.id
	
    	params[:writing_conference][:tag_ids] ||=[]

      respond_to do |format|
        if @writing_conference.update_attributes(params[:writing_conference])
          format.html { redirect_to(panel_personal_conference_back_end_writing_conferences_url) }
      		# format.js  { render 'toggle_enable' }
          format.xml  { head :ok }
        else
          format.html { render :action => "edit" }
          format.xml  { render :xml => @writing_conference.errors, :status => :unprocessable_entity }
        end
      end

    end
  
  end

  # DELETE /writing_conferences/1
  # DELETE /writing_conferences/1.xml
  def destroy
    @writing_conference = WritingConference.find(params[:id])
    @writing_conference.destroy

    respond_to do |format|
      format.html { redirect_to(panel_personal_conference_back_end_writing_conferences_url) }
      # format.xml  { head :ok }
      format.js
    end
  end

  def delete
    if params[:ids]
      writing_conferences = WritingConference.any_in(:_id => params[:ids]).destroy_all
    end
    redirect_to panel_personal_conference_back_end_writing_conferences_url(:direction => params[:direction], :sort => params[:sort], :sort_options => params[:sort_options])
  end

  def data_share

    if params[:ids]
    
      @writing_conferences = WritingConference.any_in(:_id => params[:ids])
      
      @writing_conferences.each do |writing_conference|

        writing_conference.is_hidden = params[:disable]

        writing_conference.save
      end

    end

    respond_to do |format|
    
      format.html { redirect_to(admin_users_new_interface_url(:id=>params[:user_id],:show_plugin_profile=>"WritingConference")) }
       format.json { render json: {"success"=>true}.to_json}
    end

  end
  
  
  protected
 

  # def get_index_categories(id = nil)
  #   @bulletin_categorys = []
  #   if(is_manager? || is_admin?)
  #     @bulletin_categorys = (id ? BulletinCategory.admin_manager_all.find(id).to_a : BulletinCategory.admin_manager_all)
  #   elsif is_sub_manager?
  #     @bulletin_categorys = BulletinCategory.all
  #   end
  #   @bulletin_categorys
  # end


  # def get_categorys(id = nil)
  #   @writing_conference_categorys = []
  #   if(is_manager? || is_admin?)
  #     @writing_conference_categorys = (id ? WritingConferenceCategory.admin_manager_all.find(id).to_a : WritingConferenceCategory.admin_manager_all))
  #   elsif is_sub_manager?
  #     @writing_conference_categorys = WritingConferenceCategory.all.authed_for_user(current_user,'edit')
  #   end
  #   if @writing_conference_categorys.empty? && params[:action] != "index"
  #       flash[:alert] = t("announcement.error.no_avilb_cate_for_posting")
  #       redirect_to :action => :index
  #   end
  # end
  
  def get_plugins  
    @plugins = OrbitApp::Plugin::Registration.all
  end
  
end
